/* Filename: stablemar.c */
#include <stdio.h>
#include <stdlib.h>
#include "functions.h"

int main(void)
{int n, i, j, **ppm, **ppw, *pm, *pw, *m, s, *ps;
 scanf("%d",&n);	/*eisagogi plithous andron/gynaikon apo to xristi*/
 ppm = malloc( n*sizeof(int));	/*dynamiki desmeusi nxn pinaka gia tis protimiseis ton andron*/
 if (ppm == NULL ){
   printf("Sorry, cannot allocate memory\n");
   return -1;
 }
 for ( i=0 ; i<n ; i++){
   *(ppm+i)=malloc(n*sizeof(int));
   if (*(ppm+i) == NULL ){
     printf("Sorry, cannot allocate memory\n");
     return -1;
   }
 }
 for ( i=0 ; i<n ; i++ )    /*gemisma protimiseon andron apo ton xristi*/
   for ( j=0 ; j<n ; j++ )
     scanf("%d",&ppm[i][j]);
 ppw = malloc( n*sizeof(int));  /*dynamiki desmeusi nxn pinaka gia tis protimiseis ton gynaikon*/
 if (ppw == NULL ){
   printf("Sorry, cannot allocate memory\n");
   return -1;
 }
 for ( i=0 ; i<n ; i++){
   *(ppw+i)=malloc(n*sizeof(int));
   if (*(ppw+i) == NULL ){
     printf("Sorry, cannot allocate memory\n");
     return -1;
   }
 }
 for ( i=0 ; i<n ; i++ )    /*gemisma protimiseon gynaikon apo ton xristi*/
   for ( j=0 ; j<n ; j++ )
     scanf("%d",&ppw[i][j]);
 pm = malloc( n*sizeof(int) );  /*dynamiki desmeusi n pinaka fylaksis  sizizgon ton andron*/
 if (pm == NULL ){
   printf("Sorry, cannot allocate memory\n");
   return -1;
 }
 pw = malloc( n*sizeof(int) );  /*dynamiki desmeusi n pinaka fylaksis  sizizgon ton gynaikon*/
 if (pw == NULL ){
   printf("Sorry, cannot allocate memory\n");
   return -1;
 }
 m = malloc( n*sizeof(int) );   /*dynamiki desmeusi n pinaka fylaksis protaseon gamou andron*/
 if (m == NULL ){
   printf("Sorry, cannot allocate memory\n");
   return -1;
 }
 mksingle( n, pm, pw, m );  /*klisi sinartisis pou midenizei ta pm,pw,m*/
 gashalg( n, pm, pw, ppm, ppw, m ); /*klisi synartisis Gale-Shapley algorithmou*/
 mksingle( n, pm, pw, m );
 i=0;   /*to i tha deixnei se poion andra vrisketai o elengxos,gia arxi to vazoume ston proto*/
 s=0; /*to s tha einai to synolo to lyseon pou tha vrethoun me ton 2o tropo*/
 ps=&s;
 while ( m[0]<=n )  /*mexri na teliosoun oles oi protimiseis kai tou protou*/
   i=recalg(  i,  n, ps,  pm,  pw,  ppm,  ppw, m );	/*klisi synartisis algoritmou 2ou merous*/
 printf("\n\nFound %d solution(s)\n",s);    /*ektyposi tou synolou ton lyseon*/
 for ( i=0 ; i<n ; i++) /*eleutherosi olon ton xoron pou desmeutikan*/
   free(*(ppm+i));
 free(ppm);
 for ( i=0 ; i<n ; i++)
   free(*(ppw+i));
 free(ppw);
 free(pm);
 free(pw);
 free(m);
 return 0;
}
